<template>
  <header>
    <div class="container">
      <button @click="$router.go(-1)">
        <v-icon color="white" aria-hidden="false"> mdi-chevron-left </v-icon>
      </button>
      <div class="chat-header" v-if="chat">
        <div
          class="chat-header-icon"
          :style="{
            background: `url(${
              chat.chatable.avatar
                ? chat.chatable.avatar.url.full_size
                : require('../../assets/splash.svg')
            }) no-repeat center center`,
          }"
        ></div>
        <div class="chat-header-info">
          <h3>{{ chat.chatable.name }}</h3>
          <p>{{ chat.members.length }} участников</p>
        </div>
      </div>
    </div>
  </header>
  <div class="chat">
    <div class="container">
      <div class="chat-messages">
        <chat-message
          v-for="message in messages"
          :key="message.id"
          :message="message"
          :member="member"
          :members="chat.members"
        />
      </div>
      <div class="chat-message">
        <v-text-field
          v-model="message"
          append-icon="mdi-send"
          variant="outlined"
          label="Сообщение"
          type="text"
          hide-details
          @click:append="sendMessage"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import ChatMessage from "@/components/ChatMessage";

export default {
  name: "ChatView",
  components: { ChatMessage },
  data() {
    return {
      centrifuge: "",
      messages: "",
      message: "",
      member: "",
      send_message: false,
    };
  },

  computed: {
    ...mapState({
      user: (state) => state.user.user,
      chat: (state) => state.chat.chat,
    }),
  },

  methods: {
    ...mapActions({
      loadChatInfo: "chat/loadChatInfo",
      sendChatMessage: "chat/sendChatMessage",
    }),

    sendMessage() {
      if (this.message.length && !this.send_message) {
        this.send_message = true;
        this.sendChatMessage({
          id: this.$route.params.id,
          message: this.message,
        })
          .then(() => {
            this.send_message = false;
            this.message = "";
          })
          .catch(() => {
            this.send_message = false;
          });
      }
    },

    loadChat() {
      this.loadChatInfo(this.$route.params.id).then(() => {
        this.messages = this.chat.messages;
        this.member = this.chat.members.find(
          (member) => member?.member?.user?.id === this.user.id
        ).id;
      });
    },
  },

  mounted() {
    this.loadChat();

    let Centrifuge = require("centrifuge");

    this.centrifuge = new Centrifuge(
      "wss://mch-centrifugo-c.server.bonch.dev/connection/websocket"
    );

    this.centrifuge.setToken(localStorage.getItem("broadcast_token"));

    const chat_id = parseInt(this.$route.params.id);

    this.centrifuge.subscribe(`chats:user#user::${this.user.id}`, (message) => {
      if (message.data.message.chat_id === chat_id) {
        this.messages = [message.data.message, ...this.messages];
      }
    });

    this.centrifuge.connect();
  },

  beforeUnmount() {
    this.centrifuge.disconnect();
  },
};
</script>

<style scoped lang="scss">
header {
  height: 64px;
  background-color: $blue2;
  display: flex;
  align-items: center;
  justify-content: center;
  position: fixed;
  top: 0;
  width: 100%;
  z-index: 20;
  > .container {
    display: grid;
    grid-template-columns: 24px 1fr 24px;
    grid-template-areas: "slot1 logo slot2";
    justify-items: start;
    grid-gap: $base-space * 8;
    > img {
      grid-area: logo;
    }
  }
}

.chat {
  height: calc(100% - 68px);
  > .container {
    height: 100%;
    display: grid;
    grid-template-rows: 1fr auto;
  }
  &-messages {
    max-height: 100%;
    overflow-y: auto;

    display: flex;
    flex-direction: column-reverse;
  }
  &-message {
    background: #f5f6fa;
    border-radius: 4px;
  }
}

.chat-header {
  display: grid;
  grid-template-columns: 48px 1fr;
  grid-gap: $base-space * 2;
  align-items: center;
  &-icon {
    width: 100%;
    height: 48px;
    background-size: cover !important;
    border-radius: 4px;
  }
  &-info {
    > h3 {
      font-style: normal;
      font-weight: 500;
      font-size: 16px;
      line-height: 18px;
      color: $white;
    }
    > p {
      font-weight: 400;
      font-size: 12px;
      line-height: 12px;
      color: rgba(255, 255, 255, 0.6);
    }
  }
}
</style>
